' File: load_elem_colors.BAS
' Version: Version 1
' Date: October 9, 2013
' Author: Kurt Knutson, ATA Engineering
'		  Mark Sherman, Siemens
' www.ata-plmsoftware.com
' Description: This API loads the element, property, and material colors from a .col (text) file to a similar open model. 
'              The .col file was created by the save_elem_colors.BAS API. 
'
Sub Main
    Dim App As femap.model
    Set App = feFemap()

    Dim feProp As femap.Prop
    Set feProp = App.feProp

    Dim feMatl As femap.Matl
    Set feMatl = App.feMatl

    Dim feElem As femap.Elem
    Set feElem = App.feElem

    Dim readFile As femap.Read
    Set readFile = App.feRead
    Dim fName As String
    Dim enType As String
    Dim ID As Long
    Dim color As Long

    rc = App.feFileGetName( "Material and Property Color Saver", "Color File", "*.col", True, fName )

    If rc = FE_OK Then
        rc = readFile.Open( fName, 80 )
        If rc = FE_OK Then
            While Not readFile.AtEOF
                rc = readFile.Read
                enType = readFile.Field(1)
                ID = readFile.IntField(2, 0 )
                color = readFile.IntField(3, 0)
                If ID > 0 Then
                    Select Case enType
                    Case "Matl"
                        rc = feMatl.Get( ID )
                        If rc = FE_OK Then
                        feMatl.color = color
                        rc = feMatl.Put( ID)
                        End If
                    Case "Prop"
                        rc = feProp.Get( ID )
                        If rc = FE_OK Then
                        feProp.color = color
                        rc = feProp.Put( ID)
                        End If
                    Case "Elem"
                        rc = feElem.Get( ID)
                        If rc = FE_OK Then
                        feElem.color = color
                        rc = feElem.Put( ID)
                        End If
                    End Select
                End If
            Wend
        End If
    End If

End Sub

