' File: save_elem_colors.BAS
' Version: Version 1
' Date: October 9, 2013
' Author: Kurt Knutson, ATA Engineering
'		  Mark Sherman, Siemens
' www.ata-plmsoftware.com
' Description: This API saves the element, property, and material colors from a model to a .col (text) file. This
'              file can then be loaded to a similar model using load_elem_colors.BAS.
'
Sub Main
    Dim App As femap.model
    Set App = feFemap()

    Dim feProp As femap.Prop
    Set feProp = App.feProp

    Dim feMatl As femap.Matl
    Set feMatl = App.feMatl

    Dim feElem As femap.Elem
    Set feElem = App.feElem

    Dim fName As String

    rc = App.feFileGetName( "Element, Material, and Property Color Saver", "Color File", "*.col", False, fName )

    If rc = FE_OK Then
        Open fName For Output As #1
        While feProp.Next = FE_OK
            Msg = "Prop,"+Str$(feProp.ID) +"," + Str$( feProp.color )
            Print #1, Msg
        Wend
        While feMatl.Next = FE_OK
            Msg = "Matl,"+Str$(feMatl.ID) +"," + Str$( feMatl.color )
            Print #1, Msg
        Wend
        While feElem.Next = FE_OK
            Msg = "Elem,"+Str$(feElem.ID) +"," + Str$( feElem.color )
            Print #1, Msg
        Wend
        Close #1
    End If
    
End Sub

